/* twofish.h created for the stalk program, to use the twofish.c from GnuPG */

/* Structure for an expanded Twofish key.  s contains the key-dependent
 * S-boxes composed with the MDS matrix; w contains the eight "whitening"
 * subkeys, K[0] through K[7].  k holds the remaining, "round" subkeys.  Note
 * that k[i] corresponds to what the Twofish paper calls K[i+8]. */

#ifndef STALK_TWOFISH_H
#define STALK_TWOFISH_H

typedef struct {
	u32 s[4][256], w[8], k[32];
} TWOFISH_context;

int twofish_setkey (TWOFISH_context *ctx, const byte *key, const unsigned keylen);
void twofish_encrypt (const TWOFISH_context *ctx, byte *out, const byte *in);
void twofish_decrypt (const TWOFISH_context *ctx, byte *out, const byte *in);

#endif /* STALK_TWOFISH_H */
